declare namespace tei="http://www.tei-c.org/ns/1.0";
declare function local:term-callback($term, $data) {
  <term freq="{$data[1]}" docs="{$data[2]}" n="{$data[3]}">{$term}</term>
};

let $callback := util:function(xs:QName('local:term-callback'), 2)
let $docs := doc('/db/test/test.xml')
let $rdgs := for $rdg in $docs//tei:listWit//tei:witness/@xml:id return concat('#', $rdg)
let $pool := $docs//tei:p
let $query := 'text'
let $nodes := 
  for $a in $pool|$pool//tei:rdg[tokenize(string(@wit), '\s+') = $rdgs]
  (: here nodes can be refined first by querying, if required :)
  return $a(:[ft:query(., $query)]:)
for $term in util:index-keys($nodes, '', $callback, 15000, 'lucene-index')
(:order by $term/@freq/number() descending:) 
return $term