declare namespace tei="http://www.tei-c.org/ns/1.0";
declare function local:term-callback($term, $data) {
  <term freq="{$data[1]}" docs="{$data[2]}">{$term}</term>
};

let $callback := util:function(xs:QName('local:term-callback'), 2)
let $docs := doc('/db/test/test.xml')
let $rdgs := for $rdg in $docs//tei:listWit//tei:witness/@xml:id return concat('#', $rdg)
let $pool := $docs//tei:p
let $query := 'text'

let $terms := 
  for $rdg in $rdgs
  let $nodes := 
    for $a in $pool|$pool//tei:rdg[tokenize(string(@wit), '\s+') = $rdg]
    (: here nodes can be refined first by querying, if required :)
    return $a(:[ft:query(., $query)]:)
  return
    for $term in util:index-keys($nodes, '', $callback, 15000, 'lucene-index')
    return <term wit="{$rdg}">{
      $term/(@*, node())
    }</term>

let $conflateTerms := 
  for $term in distinct-values($terms)
  let $groupTerms := $terms[. eq $term]
  return <term>
  {
    for $att in $groupTerms[1]/@*[name() != 'wit']
    return attribute {$att/name()} {sum($groupTerms/@*[name() eq $att/name()])}
  }
  {$term}
  </term>
  
for $a in $conflateTerms
(:order by $a/@freq/number() descending:)
return $a
