declare namespace tei="http://www.tei-c.org/ns/1.0";
declare function local:term-callback($term, $data) {
  <term freq="{$data[1]}" docs="{$data[2]}" n="{$data[3]}">{$term}</term>
};

let $callback := util:function(xs:QName('local:term-callback'), 2)
let $rdgs := for $a in doc('/db/test/test.xml')//tei:listWit//tei:witness/@xml:id return concat('#', $a)
let $docs := for $rdg in $rdgs return doc(concat('/db/test/test', replace($rdg, '#', '_'), '.xml'))
let $pool := $docs//tei:p
let $query := 'text'
let $nodes := 
  for $a in $pool
  (: here nodes can be refined first by querying, if required :)
  return $a(:[ft:query(., $query)]:)
for $term in util:index-keys($nodes, '', $callback, 15000, 'lucene-index')
(:order by $term/@freq/number() descending:) 
return $term